lorom

;this file made for xkas
; hook at triforce chamber at 01/204b: a9 89 85 a0 -> 5c 00 f0 61 

!FadeInTime = #$6FFF
!FadeOutTime = #$6FFF

;variable locations (these are lowrom addresses) (these addresses should match the ones on the include below)

!CodeOffset = $4df000

!SetBank = #$4c
!SetBank2 = #$4d ;should always be 1 more than SetBank1 (not sure if it's same with HiRom)
!SetOffset = #$8000
!SetOffset2 = #$8000

!MapBank = #$4d
!MapOffset = #$e100

!ColBank = #$4d
!ColOffset = #$ea00

;includes for intro 
org $4c8000
incbin introfiles/intro.set

org $4de100
incbin introfiles/intro.map

org $4dea00
incbin introfiles/intro.col

org $0cc2eb
jmp.l $4df000

;start initialization
org !CodeOffset
SEI
CLC
XCE
SEP #$30
stz $11
stz $22
LDA #$00
LDA #$80
STA $2100
LDA #$00
STA $2101
STA $2102
STA $2103
STA $2105
STA $2106
STA $2107
STA $2108
STA $2109
STA $210A
STA $210B
STA $210C
STA $210D
STA $210D
STA $210E
STA $210E
STA $210F
STA $210F
STA $2110
STA $2110
STA $2111
STA $2111
STA $2112
STA $2112
STA $2113
STA $2113
STA $2114
STA $2114

LDA #$80
STA $2115
LDA #$00
STA $2116
STA $2117
STA $211A
STA $211B
LDA #$01
STA $211B
LDA #$00
STA $211C
STA $211C
STA $211D
STA $211D
STA $211E
LDA #$01
STA $211E
LDA #$00
STA $211F
STA $211F
STA $2120
STA $2120
STA $2121
STA $2123
STA $2124
STA $2125
STA $2126
STA $2127
STA $2128
STA $2129
STA $212A
STA $212B
LDA #$01
STA $212C
LDA #$00
STA $212D
STA $212E
STA $212F
LDA #$30
STA $2130
LDA #$00
STA $2131
LDA #$E0
STA $2132
LDA #$00
STA $2133
LDA #$01	;auto read joypads
;LDA #$81
STA $4200
LDA #$FF
STA $4201
LDA #$00
STA $4202
STA $4203
STA $4204
STA $4205
STA $4206
STA $4207
STA $4208
STA $4209
STA $420A
STA $420B
STA $420C
STA $420D
REP #$30
SEP #$20
LDA #$03
STA $2105
LDA #$01
STA $212C
LDA #$00
STA $2107
LDA #$01
STA $210B
;JSR $2201

JSR Jump1

;DMA color stuff
LDX #$8000
STX $2116
LDX #$1801
STX $4300
LDX !MapOffset
STX $4302
LDA !MapBank
STA $4304
LDX #$0C00
STX $4305
LDA #$01
STA $420B
LDA #$00
STA $2121
LDX #$2200
STX $4300
LDX !ColOffset
STX $4302
LDA !ColBank
STA $4304
LDX #$0200	;512 colors
STX $4305
LDA #$01
STA $420B
JSR Jump1


;dma data information for set
;copy first half #$8000
LDX #$1000
STX $2116
LDX #$1801
STX $4300
LDX !SetOffset
STX $4302
LDA !SetBank
STA $4304
LDX #$8000
STX $4305
LDA #$01
STA $420B

; music & Sound

;LDA #$ff
;STA $2140
;stz $012c
;stz $0132
;stz $0133
;STZ $4200
;JSL $008931 ; bank3 pointer

LDA #$06
STA $2140 ; music

;LDA #$00
;STA $2142
;STA $2143 ; sfx


JSR Jump1

;dma data information
;copy bottom half #$6000 in size
LDX !SetOffset2
STX $4302
LDA !SetBank2
STA $4304
LDX #$6000
STX $4305
LDA #$01
STA $420B
Jump9:
STA $2100
INA
JSR Jump2

CMP #$10
BCC Jump9

; waitloop
        LDX #$0000
waitloop:
        LDA $4212
        AND #$80
        BEQ waitloop


LDA $4218    
AND #$F0 
bne store
lda $4219
and #$F0
bne store
bra loop2

store:
lda #01
sta $7ffc00
bra go
loop2:
        LDA $4212
        AND #$80
        BNE loop2
        INX
        CPX #$02a0 ; 60 of them would be 1 full second.
        BNE waitloop


go:

FadeRoutine()
{
CLI
LDX #$0030

Jump3:
SEP #$20
LDY #$4FFF
;lda #$2c
;sta $4321

Jump4:
DEY
BNE Jump4

Jump31:
LDY #$4FFF
;lda #$6c
;sta $2143

Jump41:
DEY
BNE Jump41

Jump32:
LDY #$fFFF
;lda #$2c
;sta $2143

Jump42:
DEY
BNE Jump42

Jump33:
LDY #$fFFF
;lda #$6c
;sta $2143

Jump43:
DEY
BNE Jump43

Jump5:
;LDA $4210
LDA $4212
AND #$80
BEQ Jump5

Jump6:	
LDA $4212	;check vblank
AND #$01
BNE Jump6

LDA $4218    
AND #$F0 

BNE Jump3  ; no keypress

; bra Jump3     ;keypress      

BRA Jump7

Jump7:
SEP #$20
LDA $4210
AND #$80
BEQ Jump7
LDA #$0F


Jump10:
STA $2100
DEC A
PHA
JSR JumpFadeOut
}



PLA
CMP #$00
BNE Jump10


LDX #$0000

;old code from beginning of unchanged rom
SEI
CLC
XCE

SEP #$30




JumpFadeOutNextScreen:

LDA #$80
STA $2100



;vram transfer tiles: tiles at 2d/8000 (1000 bytes), map at 2d/A000 (2000 bytes)
lda #$ee ;needed for pu only
sta $a0  ; needed for pu only

LDA #$10                
STA $1C    
STZ $1D 
STZ $2133  
LDA #$09                
STA $94    
STZ $95    
LDA #$13                
STA $2107  
LDA #$03                
STA $2108  
LDA #$63                
STA $2109  
LDA #$22                
STA $210B  
LDA #$07                
STA $210C  
LDA #$20               
STA $9A    
LDA #$20                
STA $9C    
LDA #$40                
STA $9D    
LDA #$80                
STA $9E 
  

;lda #$1a
;sta $10
;lda #$20
;sta $11
lda #$81		; enable temp NMI
sta.l $4200
sep #$30
lda $7ffc00
cmp #$01
beq $0a
lda #$00
sta $7ffc00
JMP.l $4e8000	;jump to to mode7
lda #$00
sta $7ffc00
LDA #$f1
STA $2140 ; music fade out
; waitloop for music fade out
        LDX #$00
waitloopmusic:
        LDA $4212
        AND #$80
        BEQ waitloopmusic
loopmusic:
        LDA $4212
        AND #$80
        BNE loopmusic
        INX
        CPX #$60 ; 60 of them would be 1 full second.
        BNE waitloopmusic
jmp.l $0cedc7         ; jump to title

Jump1:
PHA
Jump11:
LDA $4210
AND #$80
BEQ Jump11
PLA
RTS


Jump2:
LDY !FadeInTime
Jump8:
DEY
BNE Jump8
RTS


JumpFadeOut:
LDY !FadeOutTime
JumpFadeOut2:
DEY
BNE JumpFadeOut2
RTS


vblank:
 pha
 php
 sep #$20
 

; lda #$81		; enable temp NMI
; sta.l $4200

Vloop:
 lda.l $4210
 and #$80
 beq Vloop

; lda #$01		; disable again
; sta.l $4200

 plp
 pla
rts

