;dsp-1 projection demo by smkdan for guy who asked on forums
;dsp delays are ignored since this is just a quick demo and emulators don't care.  $3FC000 is where the status register is you want to test then when you actually write code for this
;offsets put the origin at the center of the screen, you can adjust them.  pilotwings shifts it a little lower than I do to fit the instrument panel at the top


lorom
org $4e8000
!framecounter	= $20
!hdma		= $60
!centerx	= $75
!centery	= $79
!framedone	= $12
!rastercenter	= $7f
!rasterhorizon	= $29
!tableAB	= $2a00
!tableCD	= $2900

Reset:
	SEI
	CLC
	XCE
	STZ $4200
	STZ $420C
	SEP #$20
	REP #$10
	LDX #$1FFF
	LDA #$03	;sprite base address
	STA $2101
	LDA #$80	;screen off and setup display parameters
	STA $2100
	LDA #$07	;mode 7
	STA $2105
	LDA #$01	;BG1 main screen
	STA $212C
	STZ $212D

	LDA #$80
	STA $211A

	JSR UploadMode7
	JSR UploadPalette
	

initial:
REP #$20   
SEP #$10                
LDA #$0000             
STA $4330  
LDA #$2132              
STA $4331  
LDA #$2930          
STA $4332  

LDX #$7E              
STX $4334  
STX $4337  
LDA #$0000           
STA $4340  
LDA #$2105        
STA $4341  

LDA #$290F      
STA $4342  
LDX #$7E        
STX $4344  
STX $4347  
LDA #$0000              
STA $4350  
LDA #$212C              
STA $4351  
LDA #$2908     
STA $4352  
LDX #$7E               
STX $4354  
STX $4357  

LDA #$0043     
STA $4360  
LDA #$211B            
STA $4361  

LDA #$2916        
STA $4362  
LDX #$7E       
STX $4364  
STX $4367  
LDA #$0043             
STA $4370  
LDA #$211D             
STA $4371  
LDA #$2923       
STA $4372 
LDX #$7E        
STX $4374  
STX $4377 

; initial settings scroll 
LDA #$4000              
STA $7F    
LDA #$0374              
STA $75    
LDA #$0000              
STA $79    

; transfer table for hdma
rep #$30 
PHB
lda #$0a00
ldx #$8900
ldy #$2900
mvn $4e7e
sep #$30
plb
   
;transfer stars to oam
rep #$30 
PHB
lda #$0220
ldx #$9500
ldy #$0800
mvn $4e7e
sep #$30
plb


	SEP #$20
	REP #$10

	lda $4210
	LDA #$81	;NMI+joypad read on
	STA $4200
	LDA #$80
	STA $2100

;nmi adjustments

	lda #$03	
	sta $95
	lda #$07  	
	sta $94   ; stored to $2105
	lda #$f8
	sta $9b   ; stored to $420c
	
	stz $012c
	stz $012d
	stz $012e
	stz $012f

	stz $012a
	stz $0128
loop:


	JSR SetupProjection



	LDA #$81	;NMI+joypad read on
	STA $4200	
        LDA #$00
	STA !framedone
	lda $7a
	cmp #$04
	bne $03
	jmp end
	LDA $4218    
	AND #$F0 
	beq $03
	jmp end
	lda $4219
	and #$F0
	beq $03
	jmp end

-	LDA !framedone
	Beq -
	
	LDA #$01	;BG1 main screen
	STA $212C
	STZ $212D
	LDA #$80
	STA $211A
	BRA loop

;-----

;projection parameters as described in manual. play with these i would add a controller input thing btu i don't feel like it right now

;for angles:
;$2000 = pi/4
;$4000 = pi/2 etc.
;ignore part of manual that says they are 8bits

!X	= 0
!Y	= 0
!Z	= 0
!FE	= 0
!ES	= 0
!AZ	= 512
!ZE	= $2800

SetupProjection:

	REP #$20
	SEP #$10
SEC                     
LDA $75    
AND #$03FF              
STA $B4    
SBC #$0080              
STA $36    
SEC                     
LDA $79    
AND #$03FF             
STA $B8    
SBC #$00EC              
STA $38    
STZ $93    
LDA $7F    
ASL A                   
ROL $93    
ASL A                   
ROL $93    
STA $91    
SEP #$20                
LDA $36    
STA $210D  
LDA $37    
STA $210D  
LDA $38    
STA $210E  
LDA $39    
STA $210E  
LDA $B4    
STA $211F  
LDA $B5    
STA $211F  
LDA $B8    
STA $2120  
LDA $B9    
STA $2120  
LDA $92    
STA $210F  
LDA $93    
STA $210F  
LDA $086C  
STA $2110  
LDA $086D  
STA $2110  
STZ $2111  
STZ $2111  
STZ $2112  
STZ $2112
lda #$f8
sta $420c  
rep #$30
lda $77
adc #$3800
sta $77
lda $79
adc #$0000
sta $79
Sep #$30
SEP #$10

	RTS

;-----
	


;-----

;CH1+CH2 are used for parameter setting
;direct mode for simplicity for now

;todo: indirect bank

	PLP
	
	RTS

;-----

;-----

UploadMode7:
	PHP
	SEP #$20
	REP #$10


;-- Load sprite bg to vram --
 
  
ldx #$6000	; vram addr $0000
    
stx $2116
    
LDX #$9400    
stx $4302
    
LDA #$4e   
sta $4304
    
ldy #$00b0	; # of bytes
    
sty $4305
  
lda #$18
    
sta $4301  
    
lda #$01
sta $4300
    
sta $420B

;-- Load map data to vram --
    
stz $2115	; increment vram address after write to $2118 (low byte)
    
ldx #$0000	; vram addr $0000
    
stx $2116
    
ldx #$1800	; Write to $2118
    
stx $4300
    
LDX #$8000
stx $4302
    
LDA #$4f
sta $4304
    
ldy #$4100	; # of bytes
    
sty $4305
    
    
lda #$01	; Enable DMA channel 0
    
sta $420B
    


;-- Load tile data to vram --
    
lda #$80	; increment vram address after write to $2119 (high byte)
    
sta $2115	
    
ldx #$0000	; vram addr $0000
    
stx $2116
    
ldx #$1900	; Write to $2119
    
stx $4300
    
LDX #$a000    
stx $4302
    
LDA #$4e   
sta $4304
    
ldy #$4000	; # of bytes
    
sty $4305
    
    
lda #$01
    
sta $420B





	PLP
	RTS

;-----

UploadPalette:
	PHP
	SEP #$20
	REP #$10

	STZ $2121
	STZ $4300
	LDA #$22
	STA $4301
	LDX #$fd00
	STX $4302
	LDA #$4e
	STA $4304
	LDX #$0102
	STX $4305
	LDA #$01
	STA $420B


	STZ $4300
	LDA #$22
	STA $4301
	LDX #$9800
	STX $4302
	LDA #$4e
	STA $4304
	LDX #$0040
	STX $4305
	LDA #$01
	STA $420B

	PLP
	RTS

;------------------------------------------

; end fade out
end:

JumpFadeOutNextScreen:
stz $420c
stz $9b
LDA #$03
STA $2105

LDA #$80
STA $2100



;vram transfer tiles: tiles at 2d/8000 (1000 bytes), map at 2d/A000 (2000 bytes)
lda #$ee ;needed for pu only
sta $a0  ; needed for pu only

LDA #$10                
STA $1C    
STZ $1D 
STZ $2133  
LDA #$09                
STA $94    
STZ $95    
LDA #$13                
STA $2107  
LDA #$03                
STA $2108  
LDA #$63                
STA $2109  
LDA #$22                
STA $210B  
LDA #$07                
STA $210C  
LDA #$20               
STA $9A    
LDA #$20                
STA $9C    
LDA #$40                
STA $9D    
LDA #$80                
STA $9E 
  

;lda #$1a
;sta $10
;lda #$20
;sta $11
lda #$81		; enable temp NMI
sta.l $4200
sep #$30

LDA #$f1
STA $2140 ; music fade out
; waitloop for music fade out
        LDX #$00
waitloopmusic:
        LDA $4212
        AND #$80
        BEQ waitloopmusic
loopmusic:
        LDA $4212
        AND #$80
        BNE loopmusic
        INX
        CPX #$60 ; 60 of them would be 1 full second.
        BNE waitloopmusic
	
lda $7a
cmp #$04
beq $04
jmp.l $0cedc7         ; jump to title
stz $13
lda #$30
sta $a0
lda #$ff
sta $a4
lda #$10
sta $20
lda #$06
sta $22
lda #$05
sta $23
jmp.l $0CEECB

;-------------------------------------

!OFFSET_X	= -128 	;(half screen width)
!OFFSET_Y	= -112 	;(half screen height) note PW uses 112 + height of status bar or something like that ($98)

NMI:
	REP #$30
	PHA
	PHX
	PHY
	SEP #$20
	LDA !framedone
	BEQ .return

	LDA !hdma
	STA $420C
	STZ !framedone
	LDA !centerx		;set center
	STA $211F
	LDA.b !centerx+1
	STA $211F
	LDA !centery
	STA $2120
	LDA.b !centery+1
	STA $2120

	REP #$20		;set offset
	LDA !centerx
	CLC
	ADC.w #!OFFSET_X
	SEP #$20
	STA $210D
	XBA
	STA $210D
	REP #$20
	LDA !centery
	SEC
	SBC !rastercenter
	CLC
	ADC.w #!OFFSET_Y
	SEP #$20
	STA $210E
	XBA
	STA $210E

.return
	REP #$30
	PLY
	PLX
	PLA
	RTI
;=====

org $4ea000
pwtiles:
	incbin gfx/pu_mode7.pc7

org $4f8000
pwmap:
	incbin gfx/pu_mode7.mp7

org $4efd00
pwcg:
	incbin gfx/pu_mode7.clr